import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_CreatePullRequestCommand, se_CreatePullRequestCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class CreatePullRequestCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodeCommit_20150413", "CreatePullRequest", {})
    .n("CodeCommitClient", "CreatePullRequestCommand")
    .f(void 0, void 0)
    .ser(se_CreatePullRequestCommand)
    .de(de_CreatePullRequestCommand)
    .build() {
}
