import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AssociateApprovalRuleTemplateWithRepositoryCommandInput, AssociateApprovalRuleTemplateWithRepositoryCommandOutput } from "../commands/AssociateApprovalRuleTemplateWithRepositoryCommand";
import { BatchAssociateApprovalRuleTemplateWithRepositoriesCommandInput, BatchAssociateApprovalRuleTemplateWithRepositoriesCommandOutput } from "../commands/BatchAssociateApprovalRuleTemplateWithRepositoriesCommand";
import { BatchDescribeMergeConflictsCommandInput, BatchDescribeMergeConflictsCommandOutput } from "../commands/BatchDescribeMergeConflictsCommand";
import { BatchDisassociateApprovalRuleTemplateFromRepositoriesCommandInput, BatchDisassociateApprovalRuleTemplateFromRepositoriesCommandOutput } from "../commands/BatchDisassociateApprovalRuleTemplateFromRepositoriesCommand";
import { BatchGetCommitsCommandInput, BatchGetCommitsCommandOutput } from "../commands/BatchGetCommitsCommand";
import { BatchGetRepositoriesCommandInput, BatchGetRepositoriesCommandOutput } from "../commands/BatchGetRepositoriesCommand";
import { CreateApprovalRuleTemplateCommandInput, CreateApprovalRuleTemplateCommandOutput } from "../commands/CreateApprovalRuleTemplateCommand";
import { CreateBranchCommandInput, CreateBranchCommandOutput } from "../commands/CreateBranchCommand";
import { CreateCommitCommandInput, CreateCommitCommandOutput } from "../commands/CreateCommitCommand";
import { CreatePullRequestApprovalRuleCommandInput, CreatePullRequestApprovalRuleCommandOutput } from "../commands/CreatePullRequestApprovalRuleCommand";
import { CreatePullRequestCommandInput, CreatePullRequestCommandOutput } from "../commands/CreatePullRequestCommand";
import { CreateRepositoryCommandInput, CreateRepositoryCommandOutput } from "../commands/CreateRepositoryCommand";
import { CreateUnreferencedMergeCommitCommandInput, CreateUnreferencedMergeCommitCommandOutput } from "../commands/CreateUnreferencedMergeCommitCommand";
import { DeleteApprovalRuleTemplateCommandInput, DeleteApprovalRuleTemplateCommandOutput } from "../commands/DeleteApprovalRuleTemplateCommand";
import { DeleteBranchCommandInput, DeleteBranchCommandOutput } from "../commands/DeleteBranchCommand";
import { DeleteCommentContentCommandInput, DeleteCommentContentCommandOutput } from "../commands/DeleteCommentContentCommand";
import { DeleteFileCommandInput, DeleteFileCommandOutput } from "../commands/DeleteFileCommand";
import { DeletePullRequestApprovalRuleCommandInput, DeletePullRequestApprovalRuleCommandOutput } from "../commands/DeletePullRequestApprovalRuleCommand";
import { DeleteRepositoryCommandInput, DeleteRepositoryCommandOutput } from "../commands/DeleteRepositoryCommand";
import { DescribeMergeConflictsCommandInput, DescribeMergeConflictsCommandOutput } from "../commands/DescribeMergeConflictsCommand";
import { DescribePullRequestEventsCommandInput, DescribePullRequestEventsCommandOutput } from "../commands/DescribePullRequestEventsCommand";
import { DisassociateApprovalRuleTemplateFromRepositoryCommandInput, DisassociateApprovalRuleTemplateFromRepositoryCommandOutput } from "../commands/DisassociateApprovalRuleTemplateFromRepositoryCommand";
import { EvaluatePullRequestApprovalRulesCommandInput, EvaluatePullRequestApprovalRulesCommandOutput } from "../commands/EvaluatePullRequestApprovalRulesCommand";
import { GetApprovalRuleTemplateCommandInput, GetApprovalRuleTemplateCommandOutput } from "../commands/GetApprovalRuleTemplateCommand";
import { GetBlobCommandInput, GetBlobCommandOutput } from "../commands/GetBlobCommand";
import { GetBranchCommandInput, GetBranchCommandOutput } from "../commands/GetBranchCommand";
import { GetCommentCommandInput, GetCommentCommandOutput } from "../commands/GetCommentCommand";
import { GetCommentReactionsCommandInput, GetCommentReactionsCommandOutput } from "../commands/GetCommentReactionsCommand";
import { GetCommentsForComparedCommitCommandInput, GetCommentsForComparedCommitCommandOutput } from "../commands/GetCommentsForComparedCommitCommand";
import { GetCommentsForPullRequestCommandInput, GetCommentsForPullRequestCommandOutput } from "../commands/GetCommentsForPullRequestCommand";
import { GetCommitCommandInput, GetCommitCommandOutput } from "../commands/GetCommitCommand";
import { GetDifferencesCommandInput, GetDifferencesCommandOutput } from "../commands/GetDifferencesCommand";
import { GetFileCommandInput, GetFileCommandOutput } from "../commands/GetFileCommand";
import { GetFolderCommandInput, GetFolderCommandOutput } from "../commands/GetFolderCommand";
import { GetMergeCommitCommandInput, GetMergeCommitCommandOutput } from "../commands/GetMergeCommitCommand";
import { GetMergeConflictsCommandInput, GetMergeConflictsCommandOutput } from "../commands/GetMergeConflictsCommand";
import { GetMergeOptionsCommandInput, GetMergeOptionsCommandOutput } from "../commands/GetMergeOptionsCommand";
import { GetPullRequestApprovalStatesCommandInput, GetPullRequestApprovalStatesCommandOutput } from "../commands/GetPullRequestApprovalStatesCommand";
import { GetPullRequestCommandInput, GetPullRequestCommandOutput } from "../commands/GetPullRequestCommand";
import { GetPullRequestOverrideStateCommandInput, GetPullRequestOverrideStateCommandOutput } from "../commands/GetPullRequestOverrideStateCommand";
import { GetRepositoryCommandInput, GetRepositoryCommandOutput } from "../commands/GetRepositoryCommand";
import { GetRepositoryTriggersCommandInput, GetRepositoryTriggersCommandOutput } from "../commands/GetRepositoryTriggersCommand";
import { ListApprovalRuleTemplatesCommandInput, ListApprovalRuleTemplatesCommandOutput } from "../commands/ListApprovalRuleTemplatesCommand";
import { ListAssociatedApprovalRuleTemplatesForRepositoryCommandInput, ListAssociatedApprovalRuleTemplatesForRepositoryCommandOutput } from "../commands/ListAssociatedApprovalRuleTemplatesForRepositoryCommand";
import { ListBranchesCommandInput, ListBranchesCommandOutput } from "../commands/ListBranchesCommand";
import { ListFileCommitHistoryCommandInput, ListFileCommitHistoryCommandOutput } from "../commands/ListFileCommitHistoryCommand";
import { ListPullRequestsCommandInput, ListPullRequestsCommandOutput } from "../commands/ListPullRequestsCommand";
import { ListRepositoriesCommandInput, ListRepositoriesCommandOutput } from "../commands/ListRepositoriesCommand";
import { ListRepositoriesForApprovalRuleTemplateCommandInput, ListRepositoriesForApprovalRuleTemplateCommandOutput } from "../commands/ListRepositoriesForApprovalRuleTemplateCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { MergeBranchesByFastForwardCommandInput, MergeBranchesByFastForwardCommandOutput } from "../commands/MergeBranchesByFastForwardCommand";
import { MergeBranchesBySquashCommandInput, MergeBranchesBySquashCommandOutput } from "../commands/MergeBranchesBySquashCommand";
import { MergeBranchesByThreeWayCommandInput, MergeBranchesByThreeWayCommandOutput } from "../commands/MergeBranchesByThreeWayCommand";
import { MergePullRequestByFastForwardCommandInput, MergePullRequestByFastForwardCommandOutput } from "../commands/MergePullRequestByFastForwardCommand";
import { MergePullRequestBySquashCommandInput, MergePullRequestBySquashCommandOutput } from "../commands/MergePullRequestBySquashCommand";
import { MergePullRequestByThreeWayCommandInput, MergePullRequestByThreeWayCommandOutput } from "../commands/MergePullRequestByThreeWayCommand";
import { OverridePullRequestApprovalRulesCommandInput, OverridePullRequestApprovalRulesCommandOutput } from "../commands/OverridePullRequestApprovalRulesCommand";
import { PostCommentForComparedCommitCommandInput, PostCommentForComparedCommitCommandOutput } from "../commands/PostCommentForComparedCommitCommand";
import { PostCommentForPullRequestCommandInput, PostCommentForPullRequestCommandOutput } from "../commands/PostCommentForPullRequestCommand";
import { PostCommentReplyCommandInput, PostCommentReplyCommandOutput } from "../commands/PostCommentReplyCommand";
import { PutCommentReactionCommandInput, PutCommentReactionCommandOutput } from "../commands/PutCommentReactionCommand";
import { PutFileCommandInput, PutFileCommandOutput } from "../commands/PutFileCommand";
import { PutRepositoryTriggersCommandInput, PutRepositoryTriggersCommandOutput } from "../commands/PutRepositoryTriggersCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { TestRepositoryTriggersCommandInput, TestRepositoryTriggersCommandOutput } from "../commands/TestRepositoryTriggersCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateApprovalRuleTemplateContentCommandInput, UpdateApprovalRuleTemplateContentCommandOutput } from "../commands/UpdateApprovalRuleTemplateContentCommand";
import { UpdateApprovalRuleTemplateDescriptionCommandInput, UpdateApprovalRuleTemplateDescriptionCommandOutput } from "../commands/UpdateApprovalRuleTemplateDescriptionCommand";
import { UpdateApprovalRuleTemplateNameCommandInput, UpdateApprovalRuleTemplateNameCommandOutput } from "../commands/UpdateApprovalRuleTemplateNameCommand";
import { UpdateCommentCommandInput, UpdateCommentCommandOutput } from "../commands/UpdateCommentCommand";
import { UpdateDefaultBranchCommandInput, UpdateDefaultBranchCommandOutput } from "../commands/UpdateDefaultBranchCommand";
import { UpdatePullRequestApprovalRuleContentCommandInput, UpdatePullRequestApprovalRuleContentCommandOutput } from "../commands/UpdatePullRequestApprovalRuleContentCommand";
import { UpdatePullRequestApprovalStateCommandInput, UpdatePullRequestApprovalStateCommandOutput } from "../commands/UpdatePullRequestApprovalStateCommand";
import { UpdatePullRequestDescriptionCommandInput, UpdatePullRequestDescriptionCommandOutput } from "../commands/UpdatePullRequestDescriptionCommand";
import { UpdatePullRequestStatusCommandInput, UpdatePullRequestStatusCommandOutput } from "../commands/UpdatePullRequestStatusCommand";
import { UpdatePullRequestTitleCommandInput, UpdatePullRequestTitleCommandOutput } from "../commands/UpdatePullRequestTitleCommand";
import { UpdateRepositoryDescriptionCommandInput, UpdateRepositoryDescriptionCommandOutput } from "../commands/UpdateRepositoryDescriptionCommand";
import { UpdateRepositoryEncryptionKeyCommandInput, UpdateRepositoryEncryptionKeyCommandOutput } from "../commands/UpdateRepositoryEncryptionKeyCommand";
import { UpdateRepositoryNameCommandInput, UpdateRepositoryNameCommandOutput } from "../commands/UpdateRepositoryNameCommand";
/**
 * serializeAws_json1_1AssociateApprovalRuleTemplateWithRepositoryCommand
 */
export declare const se_AssociateApprovalRuleTemplateWithRepositoryCommand: (input: AssociateApprovalRuleTemplateWithRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchAssociateApprovalRuleTemplateWithRepositoriesCommand
 */
export declare const se_BatchAssociateApprovalRuleTemplateWithRepositoriesCommand: (input: BatchAssociateApprovalRuleTemplateWithRepositoriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchDescribeMergeConflictsCommand
 */
export declare const se_BatchDescribeMergeConflictsCommand: (input: BatchDescribeMergeConflictsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchDisassociateApprovalRuleTemplateFromRepositoriesCommand
 */
export declare const se_BatchDisassociateApprovalRuleTemplateFromRepositoriesCommand: (input: BatchDisassociateApprovalRuleTemplateFromRepositoriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetCommitsCommand
 */
export declare const se_BatchGetCommitsCommand: (input: BatchGetCommitsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetRepositoriesCommand
 */
export declare const se_BatchGetRepositoriesCommand: (input: BatchGetRepositoriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateApprovalRuleTemplateCommand
 */
export declare const se_CreateApprovalRuleTemplateCommand: (input: CreateApprovalRuleTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateBranchCommand
 */
export declare const se_CreateBranchCommand: (input: CreateBranchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateCommitCommand
 */
export declare const se_CreateCommitCommand: (input: CreateCommitCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreatePullRequestCommand
 */
export declare const se_CreatePullRequestCommand: (input: CreatePullRequestCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreatePullRequestApprovalRuleCommand
 */
export declare const se_CreatePullRequestApprovalRuleCommand: (input: CreatePullRequestApprovalRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateRepositoryCommand
 */
export declare const se_CreateRepositoryCommand: (input: CreateRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateUnreferencedMergeCommitCommand
 */
export declare const se_CreateUnreferencedMergeCommitCommand: (input: CreateUnreferencedMergeCommitCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteApprovalRuleTemplateCommand
 */
export declare const se_DeleteApprovalRuleTemplateCommand: (input: DeleteApprovalRuleTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteBranchCommand
 */
export declare const se_DeleteBranchCommand: (input: DeleteBranchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteCommentContentCommand
 */
export declare const se_DeleteCommentContentCommand: (input: DeleteCommentContentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteFileCommand
 */
export declare const se_DeleteFileCommand: (input: DeleteFileCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeletePullRequestApprovalRuleCommand
 */
export declare const se_DeletePullRequestApprovalRuleCommand: (input: DeletePullRequestApprovalRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteRepositoryCommand
 */
export declare const se_DeleteRepositoryCommand: (input: DeleteRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeMergeConflictsCommand
 */
export declare const se_DescribeMergeConflictsCommand: (input: DescribeMergeConflictsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribePullRequestEventsCommand
 */
export declare const se_DescribePullRequestEventsCommand: (input: DescribePullRequestEventsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DisassociateApprovalRuleTemplateFromRepositoryCommand
 */
export declare const se_DisassociateApprovalRuleTemplateFromRepositoryCommand: (input: DisassociateApprovalRuleTemplateFromRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1EvaluatePullRequestApprovalRulesCommand
 */
export declare const se_EvaluatePullRequestApprovalRulesCommand: (input: EvaluatePullRequestApprovalRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetApprovalRuleTemplateCommand
 */
export declare const se_GetApprovalRuleTemplateCommand: (input: GetApprovalRuleTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetBlobCommand
 */
export declare const se_GetBlobCommand: (input: GetBlobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetBranchCommand
 */
export declare const se_GetBranchCommand: (input: GetBranchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetCommentCommand
 */
export declare const se_GetCommentCommand: (input: GetCommentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetCommentReactionsCommand
 */
export declare const se_GetCommentReactionsCommand: (input: GetCommentReactionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetCommentsForComparedCommitCommand
 */
export declare const se_GetCommentsForComparedCommitCommand: (input: GetCommentsForComparedCommitCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetCommentsForPullRequestCommand
 */
export declare const se_GetCommentsForPullRequestCommand: (input: GetCommentsForPullRequestCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetCommitCommand
 */
export declare const se_GetCommitCommand: (input: GetCommitCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDifferencesCommand
 */
export declare const se_GetDifferencesCommand: (input: GetDifferencesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetFileCommand
 */
export declare const se_GetFileCommand: (input: GetFileCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetFolderCommand
 */
export declare const se_GetFolderCommand: (input: GetFolderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetMergeCommitCommand
 */
export declare const se_GetMergeCommitCommand: (input: GetMergeCommitCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetMergeConflictsCommand
 */
export declare const se_GetMergeConflictsCommand: (input: GetMergeConflictsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetMergeOptionsCommand
 */
export declare const se_GetMergeOptionsCommand: (input: GetMergeOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPullRequestCommand
 */
export declare const se_GetPullRequestCommand: (input: GetPullRequestCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPullRequestApprovalStatesCommand
 */
export declare const se_GetPullRequestApprovalStatesCommand: (input: GetPullRequestApprovalStatesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPullRequestOverrideStateCommand
 */
export declare const se_GetPullRequestOverrideStateCommand: (input: GetPullRequestOverrideStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetRepositoryCommand
 */
export declare const se_GetRepositoryCommand: (input: GetRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetRepositoryTriggersCommand
 */
export declare const se_GetRepositoryTriggersCommand: (input: GetRepositoryTriggersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApprovalRuleTemplatesCommand
 */
export declare const se_ListApprovalRuleTemplatesCommand: (input: ListApprovalRuleTemplatesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAssociatedApprovalRuleTemplatesForRepositoryCommand
 */
export declare const se_ListAssociatedApprovalRuleTemplatesForRepositoryCommand: (input: ListAssociatedApprovalRuleTemplatesForRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListBranchesCommand
 */
export declare const se_ListBranchesCommand: (input: ListBranchesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListFileCommitHistoryCommand
 */
export declare const se_ListFileCommitHistoryCommand: (input: ListFileCommitHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListPullRequestsCommand
 */
export declare const se_ListPullRequestsCommand: (input: ListPullRequestsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListRepositoriesCommand
 */
export declare const se_ListRepositoriesCommand: (input: ListRepositoriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListRepositoriesForApprovalRuleTemplateCommand
 */
export declare const se_ListRepositoriesForApprovalRuleTemplateCommand: (input: ListRepositoriesForApprovalRuleTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1MergeBranchesByFastForwardCommand
 */
export declare const se_MergeBranchesByFastForwardCommand: (input: MergeBranchesByFastForwardCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1MergeBranchesBySquashCommand
 */
export declare const se_MergeBranchesBySquashCommand: (input: MergeBranchesBySquashCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1MergeBranchesByThreeWayCommand
 */
export declare const se_MergeBranchesByThreeWayCommand: (input: MergeBranchesByThreeWayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1MergePullRequestByFastForwardCommand
 */
export declare const se_MergePullRequestByFastForwardCommand: (input: MergePullRequestByFastForwardCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1MergePullRequestBySquashCommand
 */
export declare const se_MergePullRequestBySquashCommand: (input: MergePullRequestBySquashCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1MergePullRequestByThreeWayCommand
 */
export declare const se_MergePullRequestByThreeWayCommand: (input: MergePullRequestByThreeWayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1OverridePullRequestApprovalRulesCommand
 */
export declare const se_OverridePullRequestApprovalRulesCommand: (input: OverridePullRequestApprovalRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PostCommentForComparedCommitCommand
 */
export declare const se_PostCommentForComparedCommitCommand: (input: PostCommentForComparedCommitCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PostCommentForPullRequestCommand
 */
export declare const se_PostCommentForPullRequestCommand: (input: PostCommentForPullRequestCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PostCommentReplyCommand
 */
export declare const se_PostCommentReplyCommand: (input: PostCommentReplyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutCommentReactionCommand
 */
export declare const se_PutCommentReactionCommand: (input: PutCommentReactionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutFileCommand
 */
export declare const se_PutFileCommand: (input: PutFileCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutRepositoryTriggersCommand
 */
export declare const se_PutRepositoryTriggersCommand: (input: PutRepositoryTriggersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TestRepositoryTriggersCommand
 */
export declare const se_TestRepositoryTriggersCommand: (input: TestRepositoryTriggersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateApprovalRuleTemplateContentCommand
 */
export declare const se_UpdateApprovalRuleTemplateContentCommand: (input: UpdateApprovalRuleTemplateContentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateApprovalRuleTemplateDescriptionCommand
 */
export declare const se_UpdateApprovalRuleTemplateDescriptionCommand: (input: UpdateApprovalRuleTemplateDescriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateApprovalRuleTemplateNameCommand
 */
export declare const se_UpdateApprovalRuleTemplateNameCommand: (input: UpdateApprovalRuleTemplateNameCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateCommentCommand
 */
export declare const se_UpdateCommentCommand: (input: UpdateCommentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateDefaultBranchCommand
 */
export declare const se_UpdateDefaultBranchCommand: (input: UpdateDefaultBranchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePullRequestApprovalRuleContentCommand
 */
export declare const se_UpdatePullRequestApprovalRuleContentCommand: (input: UpdatePullRequestApprovalRuleContentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePullRequestApprovalStateCommand
 */
export declare const se_UpdatePullRequestApprovalStateCommand: (input: UpdatePullRequestApprovalStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePullRequestDescriptionCommand
 */
export declare const se_UpdatePullRequestDescriptionCommand: (input: UpdatePullRequestDescriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePullRequestStatusCommand
 */
export declare const se_UpdatePullRequestStatusCommand: (input: UpdatePullRequestStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePullRequestTitleCommand
 */
export declare const se_UpdatePullRequestTitleCommand: (input: UpdatePullRequestTitleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateRepositoryDescriptionCommand
 */
export declare const se_UpdateRepositoryDescriptionCommand: (input: UpdateRepositoryDescriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateRepositoryEncryptionKeyCommand
 */
export declare const se_UpdateRepositoryEncryptionKeyCommand: (input: UpdateRepositoryEncryptionKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateRepositoryNameCommand
 */
export declare const se_UpdateRepositoryNameCommand: (input: UpdateRepositoryNameCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1AssociateApprovalRuleTemplateWithRepositoryCommand
 */
export declare const de_AssociateApprovalRuleTemplateWithRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateApprovalRuleTemplateWithRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1BatchAssociateApprovalRuleTemplateWithRepositoriesCommand
 */
export declare const de_BatchAssociateApprovalRuleTemplateWithRepositoriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchAssociateApprovalRuleTemplateWithRepositoriesCommandOutput>;
/**
 * deserializeAws_json1_1BatchDescribeMergeConflictsCommand
 */
export declare const de_BatchDescribeMergeConflictsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchDescribeMergeConflictsCommandOutput>;
/**
 * deserializeAws_json1_1BatchDisassociateApprovalRuleTemplateFromRepositoriesCommand
 */
export declare const de_BatchDisassociateApprovalRuleTemplateFromRepositoriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchDisassociateApprovalRuleTemplateFromRepositoriesCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetCommitsCommand
 */
export declare const de_BatchGetCommitsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetCommitsCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetRepositoriesCommand
 */
export declare const de_BatchGetRepositoriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetRepositoriesCommandOutput>;
/**
 * deserializeAws_json1_1CreateApprovalRuleTemplateCommand
 */
export declare const de_CreateApprovalRuleTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateApprovalRuleTemplateCommandOutput>;
/**
 * deserializeAws_json1_1CreateBranchCommand
 */
export declare const de_CreateBranchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateBranchCommandOutput>;
/**
 * deserializeAws_json1_1CreateCommitCommand
 */
export declare const de_CreateCommitCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCommitCommandOutput>;
/**
 * deserializeAws_json1_1CreatePullRequestCommand
 */
export declare const de_CreatePullRequestCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePullRequestCommandOutput>;
/**
 * deserializeAws_json1_1CreatePullRequestApprovalRuleCommand
 */
export declare const de_CreatePullRequestApprovalRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePullRequestApprovalRuleCommandOutput>;
/**
 * deserializeAws_json1_1CreateRepositoryCommand
 */
export declare const de_CreateRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1CreateUnreferencedMergeCommitCommand
 */
export declare const de_CreateUnreferencedMergeCommitCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateUnreferencedMergeCommitCommandOutput>;
/**
 * deserializeAws_json1_1DeleteApprovalRuleTemplateCommand
 */
export declare const de_DeleteApprovalRuleTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApprovalRuleTemplateCommandOutput>;
/**
 * deserializeAws_json1_1DeleteBranchCommand
 */
export declare const de_DeleteBranchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteBranchCommandOutput>;
/**
 * deserializeAws_json1_1DeleteCommentContentCommand
 */
export declare const de_DeleteCommentContentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCommentContentCommandOutput>;
/**
 * deserializeAws_json1_1DeleteFileCommand
 */
export declare const de_DeleteFileCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteFileCommandOutput>;
/**
 * deserializeAws_json1_1DeletePullRequestApprovalRuleCommand
 */
export declare const de_DeletePullRequestApprovalRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePullRequestApprovalRuleCommandOutput>;
/**
 * deserializeAws_json1_1DeleteRepositoryCommand
 */
export declare const de_DeleteRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1DescribeMergeConflictsCommand
 */
export declare const de_DescribeMergeConflictsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeMergeConflictsCommandOutput>;
/**
 * deserializeAws_json1_1DescribePullRequestEventsCommand
 */
export declare const de_DescribePullRequestEventsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePullRequestEventsCommandOutput>;
/**
 * deserializeAws_json1_1DisassociateApprovalRuleTemplateFromRepositoryCommand
 */
export declare const de_DisassociateApprovalRuleTemplateFromRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateApprovalRuleTemplateFromRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1EvaluatePullRequestApprovalRulesCommand
 */
export declare const de_EvaluatePullRequestApprovalRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EvaluatePullRequestApprovalRulesCommandOutput>;
/**
 * deserializeAws_json1_1GetApprovalRuleTemplateCommand
 */
export declare const de_GetApprovalRuleTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApprovalRuleTemplateCommandOutput>;
/**
 * deserializeAws_json1_1GetBlobCommand
 */
export declare const de_GetBlobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetBlobCommandOutput>;
/**
 * deserializeAws_json1_1GetBranchCommand
 */
export declare const de_GetBranchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetBranchCommandOutput>;
/**
 * deserializeAws_json1_1GetCommentCommand
 */
export declare const de_GetCommentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCommentCommandOutput>;
/**
 * deserializeAws_json1_1GetCommentReactionsCommand
 */
export declare const de_GetCommentReactionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCommentReactionsCommandOutput>;
/**
 * deserializeAws_json1_1GetCommentsForComparedCommitCommand
 */
export declare const de_GetCommentsForComparedCommitCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCommentsForComparedCommitCommandOutput>;
/**
 * deserializeAws_json1_1GetCommentsForPullRequestCommand
 */
export declare const de_GetCommentsForPullRequestCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCommentsForPullRequestCommandOutput>;
/**
 * deserializeAws_json1_1GetCommitCommand
 */
export declare const de_GetCommitCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCommitCommandOutput>;
/**
 * deserializeAws_json1_1GetDifferencesCommand
 */
export declare const de_GetDifferencesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDifferencesCommandOutput>;
/**
 * deserializeAws_json1_1GetFileCommand
 */
export declare const de_GetFileCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetFileCommandOutput>;
/**
 * deserializeAws_json1_1GetFolderCommand
 */
export declare const de_GetFolderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetFolderCommandOutput>;
/**
 * deserializeAws_json1_1GetMergeCommitCommand
 */
export declare const de_GetMergeCommitCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMergeCommitCommandOutput>;
/**
 * deserializeAws_json1_1GetMergeConflictsCommand
 */
export declare const de_GetMergeConflictsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMergeConflictsCommandOutput>;
/**
 * deserializeAws_json1_1GetMergeOptionsCommand
 */
export declare const de_GetMergeOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMergeOptionsCommandOutput>;
/**
 * deserializeAws_json1_1GetPullRequestCommand
 */
export declare const de_GetPullRequestCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPullRequestCommandOutput>;
/**
 * deserializeAws_json1_1GetPullRequestApprovalStatesCommand
 */
export declare const de_GetPullRequestApprovalStatesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPullRequestApprovalStatesCommandOutput>;
/**
 * deserializeAws_json1_1GetPullRequestOverrideStateCommand
 */
export declare const de_GetPullRequestOverrideStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPullRequestOverrideStateCommandOutput>;
/**
 * deserializeAws_json1_1GetRepositoryCommand
 */
export declare const de_GetRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1GetRepositoryTriggersCommand
 */
export declare const de_GetRepositoryTriggersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRepositoryTriggersCommandOutput>;
/**
 * deserializeAws_json1_1ListApprovalRuleTemplatesCommand
 */
export declare const de_ListApprovalRuleTemplatesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApprovalRuleTemplatesCommandOutput>;
/**
 * deserializeAws_json1_1ListAssociatedApprovalRuleTemplatesForRepositoryCommand
 */
export declare const de_ListAssociatedApprovalRuleTemplatesForRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAssociatedApprovalRuleTemplatesForRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1ListBranchesCommand
 */
export declare const de_ListBranchesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListBranchesCommandOutput>;
/**
 * deserializeAws_json1_1ListFileCommitHistoryCommand
 */
export declare const de_ListFileCommitHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListFileCommitHistoryCommandOutput>;
/**
 * deserializeAws_json1_1ListPullRequestsCommand
 */
export declare const de_ListPullRequestsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPullRequestsCommandOutput>;
/**
 * deserializeAws_json1_1ListRepositoriesCommand
 */
export declare const de_ListRepositoriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRepositoriesCommandOutput>;
/**
 * deserializeAws_json1_1ListRepositoriesForApprovalRuleTemplateCommand
 */
export declare const de_ListRepositoriesForApprovalRuleTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRepositoriesForApprovalRuleTemplateCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1MergeBranchesByFastForwardCommand
 */
export declare const de_MergeBranchesByFastForwardCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MergeBranchesByFastForwardCommandOutput>;
/**
 * deserializeAws_json1_1MergeBranchesBySquashCommand
 */
export declare const de_MergeBranchesBySquashCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MergeBranchesBySquashCommandOutput>;
/**
 * deserializeAws_json1_1MergeBranchesByThreeWayCommand
 */
export declare const de_MergeBranchesByThreeWayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MergeBranchesByThreeWayCommandOutput>;
/**
 * deserializeAws_json1_1MergePullRequestByFastForwardCommand
 */
export declare const de_MergePullRequestByFastForwardCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MergePullRequestByFastForwardCommandOutput>;
/**
 * deserializeAws_json1_1MergePullRequestBySquashCommand
 */
export declare const de_MergePullRequestBySquashCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MergePullRequestBySquashCommandOutput>;
/**
 * deserializeAws_json1_1MergePullRequestByThreeWayCommand
 */
export declare const de_MergePullRequestByThreeWayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MergePullRequestByThreeWayCommandOutput>;
/**
 * deserializeAws_json1_1OverridePullRequestApprovalRulesCommand
 */
export declare const de_OverridePullRequestApprovalRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<OverridePullRequestApprovalRulesCommandOutput>;
/**
 * deserializeAws_json1_1PostCommentForComparedCommitCommand
 */
export declare const de_PostCommentForComparedCommitCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PostCommentForComparedCommitCommandOutput>;
/**
 * deserializeAws_json1_1PostCommentForPullRequestCommand
 */
export declare const de_PostCommentForPullRequestCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PostCommentForPullRequestCommandOutput>;
/**
 * deserializeAws_json1_1PostCommentReplyCommand
 */
export declare const de_PostCommentReplyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PostCommentReplyCommandOutput>;
/**
 * deserializeAws_json1_1PutCommentReactionCommand
 */
export declare const de_PutCommentReactionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutCommentReactionCommandOutput>;
/**
 * deserializeAws_json1_1PutFileCommand
 */
export declare const de_PutFileCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutFileCommandOutput>;
/**
 * deserializeAws_json1_1PutRepositoryTriggersCommand
 */
export declare const de_PutRepositoryTriggersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRepositoryTriggersCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1TestRepositoryTriggersCommand
 */
export declare const de_TestRepositoryTriggersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TestRepositoryTriggersCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateApprovalRuleTemplateContentCommand
 */
export declare const de_UpdateApprovalRuleTemplateContentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateApprovalRuleTemplateContentCommandOutput>;
/**
 * deserializeAws_json1_1UpdateApprovalRuleTemplateDescriptionCommand
 */
export declare const de_UpdateApprovalRuleTemplateDescriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateApprovalRuleTemplateDescriptionCommandOutput>;
/**
 * deserializeAws_json1_1UpdateApprovalRuleTemplateNameCommand
 */
export declare const de_UpdateApprovalRuleTemplateNameCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateApprovalRuleTemplateNameCommandOutput>;
/**
 * deserializeAws_json1_1UpdateCommentCommand
 */
export declare const de_UpdateCommentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateCommentCommandOutput>;
/**
 * deserializeAws_json1_1UpdateDefaultBranchCommand
 */
export declare const de_UpdateDefaultBranchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDefaultBranchCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePullRequestApprovalRuleContentCommand
 */
export declare const de_UpdatePullRequestApprovalRuleContentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePullRequestApprovalRuleContentCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePullRequestApprovalStateCommand
 */
export declare const de_UpdatePullRequestApprovalStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePullRequestApprovalStateCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePullRequestDescriptionCommand
 */
export declare const de_UpdatePullRequestDescriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePullRequestDescriptionCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePullRequestStatusCommand
 */
export declare const de_UpdatePullRequestStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePullRequestStatusCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePullRequestTitleCommand
 */
export declare const de_UpdatePullRequestTitleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePullRequestTitleCommandOutput>;
/**
 * deserializeAws_json1_1UpdateRepositoryDescriptionCommand
 */
export declare const de_UpdateRepositoryDescriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRepositoryDescriptionCommandOutput>;
/**
 * deserializeAws_json1_1UpdateRepositoryEncryptionKeyCommand
 */
export declare const de_UpdateRepositoryEncryptionKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRepositoryEncryptionKeyCommandOutput>;
/**
 * deserializeAws_json1_1UpdateRepositoryNameCommand
 */
export declare const de_UpdateRepositoryNameCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRepositoryNameCommandOutput>;
