import { ECRServiceException as __BaseException } from "./ECRServiceException";
export const LayerFailureCode = {
    InvalidLayerDigest: "InvalidLayerDigest",
    MissingLayerDigest: "MissingLayerDigest",
};
export const LayerAvailability = {
    AVAILABLE: "AVAILABLE",
    UNAVAILABLE: "UNAVAILABLE",
};
export class InvalidParameterException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidParameterException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidParameterException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidParameterException.prototype);
    }
}
export class RepositoryNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "RepositoryNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "RepositoryNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, RepositoryNotFoundException.prototype);
    }
}
export class ServerException extends __BaseException {
    constructor(opts) {
        super({
            name: "ServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "ServerException";
        this.$fault = "server";
        Object.setPrototypeOf(this, ServerException.prototype);
    }
}
export const ImageFailureCode = {
    ImageNotFound: "ImageNotFound",
    ImageReferencedByManifestList: "ImageReferencedByManifestList",
    ImageTagDoesNotMatchDigest: "ImageTagDoesNotMatchDigest",
    InvalidImageDigest: "InvalidImageDigest",
    InvalidImageTag: "InvalidImageTag",
    KmsError: "KmsError",
    MissingDigestAndTag: "MissingDigestAndTag",
    UpstreamAccessDenied: "UpstreamAccessDenied",
    UpstreamTooManyRequests: "UpstreamTooManyRequests",
    UpstreamUnavailable: "UpstreamUnavailable",
};
export class LimitExceededException extends __BaseException {
    constructor(opts) {
        super({
            name: "LimitExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "LimitExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LimitExceededException.prototype);
    }
}
export class UnableToGetUpstreamImageException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnableToGetUpstreamImageException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnableToGetUpstreamImageException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnableToGetUpstreamImageException.prototype);
    }
}
export const ScanningConfigurationFailureCode = {
    REPOSITORY_NOT_FOUND: "REPOSITORY_NOT_FOUND",
};
export const ScanningRepositoryFilterType = {
    WILDCARD: "WILDCARD",
};
export const ScanFrequency = {
    CONTINUOUS_SCAN: "CONTINUOUS_SCAN",
    MANUAL: "MANUAL",
    SCAN_ON_PUSH: "SCAN_ON_PUSH",
};
export class ValidationException extends __BaseException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
    }
}
export class EmptyUploadException extends __BaseException {
    constructor(opts) {
        super({
            name: "EmptyUploadException",
            $fault: "client",
            ...opts,
        });
        this.name = "EmptyUploadException";
        this.$fault = "client";
        Object.setPrototypeOf(this, EmptyUploadException.prototype);
    }
}
export class InvalidLayerException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidLayerException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidLayerException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidLayerException.prototype);
    }
}
export class KmsException extends __BaseException {
    constructor(opts) {
        super({
            name: "KmsException",
            $fault: "client",
            ...opts,
        });
        this.name = "KmsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, KmsException.prototype);
        this.kmsError = opts.kmsError;
    }
}
export class LayerAlreadyExistsException extends __BaseException {
    constructor(opts) {
        super({
            name: "LayerAlreadyExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "LayerAlreadyExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LayerAlreadyExistsException.prototype);
    }
}
export class LayerPartTooSmallException extends __BaseException {
    constructor(opts) {
        super({
            name: "LayerPartTooSmallException",
            $fault: "client",
            ...opts,
        });
        this.name = "LayerPartTooSmallException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LayerPartTooSmallException.prototype);
    }
}
export class UploadNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "UploadNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "UploadNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UploadNotFoundException.prototype);
    }
}
export const UpstreamRegistry = {
    AzureContainerRegistry: "azure-container-registry",
    DockerHub: "docker-hub",
    EcrPublic: "ecr-public",
    GitHubContainerRegistry: "github-container-registry",
    GitLabContainerRegistry: "gitlab-container-registry",
    K8s: "k8s",
    Quay: "quay",
};
export class PullThroughCacheRuleAlreadyExistsException extends __BaseException {
    constructor(opts) {
        super({
            name: "PullThroughCacheRuleAlreadyExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "PullThroughCacheRuleAlreadyExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, PullThroughCacheRuleAlreadyExistsException.prototype);
    }
}
export class SecretNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "SecretNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "SecretNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, SecretNotFoundException.prototype);
    }
}
export class UnableToAccessSecretException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnableToAccessSecretException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnableToAccessSecretException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnableToAccessSecretException.prototype);
    }
}
export class UnableToDecryptSecretValueException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnableToDecryptSecretValueException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnableToDecryptSecretValueException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnableToDecryptSecretValueException.prototype);
    }
}
export class UnsupportedUpstreamRegistryException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnsupportedUpstreamRegistryException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnsupportedUpstreamRegistryException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnsupportedUpstreamRegistryException.prototype);
    }
}
export const EncryptionType = {
    AES256: "AES256",
    KMS: "KMS",
    KMS_DSSE: "KMS_DSSE",
};
export const ImageTagMutability = {
    IMMUTABLE: "IMMUTABLE",
    MUTABLE: "MUTABLE",
};
export class InvalidTagParameterException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidTagParameterException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidTagParameterException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidTagParameterException.prototype);
    }
}
export class RepositoryAlreadyExistsException extends __BaseException {
    constructor(opts) {
        super({
            name: "RepositoryAlreadyExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "RepositoryAlreadyExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, RepositoryAlreadyExistsException.prototype);
    }
}
export class TooManyTagsException extends __BaseException {
    constructor(opts) {
        super({
            name: "TooManyTagsException",
            $fault: "client",
            ...opts,
        });
        this.name = "TooManyTagsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, TooManyTagsException.prototype);
    }
}
export const RCTAppliedFor = {
    PULL_THROUGH_CACHE: "PULL_THROUGH_CACHE",
    REPLICATION: "REPLICATION",
};
export class TemplateAlreadyExistsException extends __BaseException {
    constructor(opts) {
        super({
            name: "TemplateAlreadyExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "TemplateAlreadyExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, TemplateAlreadyExistsException.prototype);
    }
}
export class LifecyclePolicyNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "LifecyclePolicyNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "LifecyclePolicyNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LifecyclePolicyNotFoundException.prototype);
    }
}
export class PullThroughCacheRuleNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "PullThroughCacheRuleNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "PullThroughCacheRuleNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, PullThroughCacheRuleNotFoundException.prototype);
    }
}
export class RegistryPolicyNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "RegistryPolicyNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "RegistryPolicyNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, RegistryPolicyNotFoundException.prototype);
    }
}
export class RepositoryNotEmptyException extends __BaseException {
    constructor(opts) {
        super({
            name: "RepositoryNotEmptyException",
            $fault: "client",
            ...opts,
        });
        this.name = "RepositoryNotEmptyException";
        this.$fault = "client";
        Object.setPrototypeOf(this, RepositoryNotEmptyException.prototype);
    }
}
export class TemplateNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "TemplateNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "TemplateNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, TemplateNotFoundException.prototype);
    }
}
export class RepositoryPolicyNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "RepositoryPolicyNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "RepositoryPolicyNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, RepositoryPolicyNotFoundException.prototype);
    }
}
export const ReplicationStatus = {
    COMPLETE: "COMPLETE",
    FAILED: "FAILED",
    IN_PROGRESS: "IN_PROGRESS",
};
export class ImageNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "ImageNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ImageNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ImageNotFoundException.prototype);
    }
}
export const TagStatus = {
    ANY: "ANY",
    TAGGED: "TAGGED",
    UNTAGGED: "UNTAGGED",
};
export const FindingSeverity = {
    CRITICAL: "CRITICAL",
    HIGH: "HIGH",
    INFORMATIONAL: "INFORMATIONAL",
    LOW: "LOW",
    MEDIUM: "MEDIUM",
    UNDEFINED: "UNDEFINED",
};
export const ScanStatus = {
    ACTIVE: "ACTIVE",
    COMPLETE: "COMPLETE",
    FAILED: "FAILED",
    FINDINGS_UNAVAILABLE: "FINDINGS_UNAVAILABLE",
    IN_PROGRESS: "IN_PROGRESS",
    PENDING: "PENDING",
    SCAN_ELIGIBILITY_EXPIRED: "SCAN_ELIGIBILITY_EXPIRED",
    UNSUPPORTED_IMAGE: "UNSUPPORTED_IMAGE",
};
export class ScanNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "ScanNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ScanNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ScanNotFoundException.prototype);
    }
}
export const RepositoryFilterType = {
    PREFIX_MATCH: "PREFIX_MATCH",
};
export class LayerInaccessibleException extends __BaseException {
    constructor(opts) {
        super({
            name: "LayerInaccessibleException",
            $fault: "client",
            ...opts,
        });
        this.name = "LayerInaccessibleException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LayerInaccessibleException.prototype);
    }
}
export class LayersNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "LayersNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "LayersNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LayersNotFoundException.prototype);
    }
}
export class UnableToGetUpstreamLayerException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnableToGetUpstreamLayerException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnableToGetUpstreamLayerException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnableToGetUpstreamLayerException.prototype);
    }
}
export const ImageActionType = {
    EXPIRE: "EXPIRE",
};
export const LifecyclePolicyPreviewStatus = {
    COMPLETE: "COMPLETE",
    EXPIRED: "EXPIRED",
    FAILED: "FAILED",
    IN_PROGRESS: "IN_PROGRESS",
};
export class LifecyclePolicyPreviewNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "LifecyclePolicyPreviewNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "LifecyclePolicyPreviewNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LifecyclePolicyPreviewNotFoundException.prototype);
    }
}
export const ScanType = {
    BASIC: "BASIC",
    ENHANCED: "ENHANCED",
};
export class ImageAlreadyExistsException extends __BaseException {
    constructor(opts) {
        super({
            name: "ImageAlreadyExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "ImageAlreadyExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ImageAlreadyExistsException.prototype);
    }
}
export class ImageDigestDoesNotMatchException extends __BaseException {
    constructor(opts) {
        super({
            name: "ImageDigestDoesNotMatchException",
            $fault: "client",
            ...opts,
        });
        this.name = "ImageDigestDoesNotMatchException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ImageDigestDoesNotMatchException.prototype);
    }
}
export class ImageTagAlreadyExistsException extends __BaseException {
    constructor(opts) {
        super({
            name: "ImageTagAlreadyExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "ImageTagAlreadyExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ImageTagAlreadyExistsException.prototype);
    }
}
export class ReferencedImagesNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "ReferencedImagesNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ReferencedImagesNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ReferencedImagesNotFoundException.prototype);
    }
}
export class UnsupportedImageTypeException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnsupportedImageTypeException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnsupportedImageTypeException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnsupportedImageTypeException.prototype);
    }
}
export class LifecyclePolicyPreviewInProgressException extends __BaseException {
    constructor(opts) {
        super({
            name: "LifecyclePolicyPreviewInProgressException",
            $fault: "client",
            ...opts,
        });
        this.name = "LifecyclePolicyPreviewInProgressException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LifecyclePolicyPreviewInProgressException.prototype);
    }
}
export class InvalidLayerPartException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidLayerPartException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidLayerPartException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidLayerPartException.prototype);
        this.registryId = opts.registryId;
        this.repositoryName = opts.repositoryName;
        this.uploadId = opts.uploadId;
        this.lastValidByteReceived = opts.lastValidByteReceived;
    }
}
