import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { BatchCheckLayerAvailabilityCommandInput, BatchCheckLayerAvailabilityCommandOutput } from "../commands/BatchCheckLayerAvailabilityCommand";
import { BatchDeleteImageCommandInput, BatchDeleteImageCommandOutput } from "../commands/BatchDeleteImageCommand";
import { BatchGetImageCommandInput, BatchGetImageCommandOutput } from "../commands/BatchGetImageCommand";
import { BatchGetRepositoryScanningConfigurationCommandInput, BatchGetRepositoryScanningConfigurationCommandOutput } from "../commands/BatchGetRepositoryScanningConfigurationCommand";
import { CompleteLayerUploadCommandInput, CompleteLayerUploadCommandOutput } from "../commands/CompleteLayerUploadCommand";
import { CreatePullThroughCacheRuleCommandInput, CreatePullThroughCacheRuleCommandOutput } from "../commands/CreatePullThroughCacheRuleCommand";
import { CreateRepositoryCommandInput, CreateRepositoryCommandOutput } from "../commands/CreateRepositoryCommand";
import { CreateRepositoryCreationTemplateCommandInput, CreateRepositoryCreationTemplateCommandOutput } from "../commands/CreateRepositoryCreationTemplateCommand";
import { DeleteLifecyclePolicyCommandInput, DeleteLifecyclePolicyCommandOutput } from "../commands/DeleteLifecyclePolicyCommand";
import { DeletePullThroughCacheRuleCommandInput, DeletePullThroughCacheRuleCommandOutput } from "../commands/DeletePullThroughCacheRuleCommand";
import { DeleteRegistryPolicyCommandInput, DeleteRegistryPolicyCommandOutput } from "../commands/DeleteRegistryPolicyCommand";
import { DeleteRepositoryCommandInput, DeleteRepositoryCommandOutput } from "../commands/DeleteRepositoryCommand";
import { DeleteRepositoryCreationTemplateCommandInput, DeleteRepositoryCreationTemplateCommandOutput } from "../commands/DeleteRepositoryCreationTemplateCommand";
import { DeleteRepositoryPolicyCommandInput, DeleteRepositoryPolicyCommandOutput } from "../commands/DeleteRepositoryPolicyCommand";
import { DescribeImageReplicationStatusCommandInput, DescribeImageReplicationStatusCommandOutput } from "../commands/DescribeImageReplicationStatusCommand";
import { DescribeImageScanFindingsCommandInput, DescribeImageScanFindingsCommandOutput } from "../commands/DescribeImageScanFindingsCommand";
import { DescribeImagesCommandInput, DescribeImagesCommandOutput } from "../commands/DescribeImagesCommand";
import { DescribePullThroughCacheRulesCommandInput, DescribePullThroughCacheRulesCommandOutput } from "../commands/DescribePullThroughCacheRulesCommand";
import { DescribeRegistryCommandInput, DescribeRegistryCommandOutput } from "../commands/DescribeRegistryCommand";
import { DescribeRepositoriesCommandInput, DescribeRepositoriesCommandOutput } from "../commands/DescribeRepositoriesCommand";
import { DescribeRepositoryCreationTemplatesCommandInput, DescribeRepositoryCreationTemplatesCommandOutput } from "../commands/DescribeRepositoryCreationTemplatesCommand";
import { GetAccountSettingCommandInput, GetAccountSettingCommandOutput } from "../commands/GetAccountSettingCommand";
import { GetAuthorizationTokenCommandInput, GetAuthorizationTokenCommandOutput } from "../commands/GetAuthorizationTokenCommand";
import { GetDownloadUrlForLayerCommandInput, GetDownloadUrlForLayerCommandOutput } from "../commands/GetDownloadUrlForLayerCommand";
import { GetLifecyclePolicyCommandInput, GetLifecyclePolicyCommandOutput } from "../commands/GetLifecyclePolicyCommand";
import { GetLifecyclePolicyPreviewCommandInput, GetLifecyclePolicyPreviewCommandOutput } from "../commands/GetLifecyclePolicyPreviewCommand";
import { GetRegistryPolicyCommandInput, GetRegistryPolicyCommandOutput } from "../commands/GetRegistryPolicyCommand";
import { GetRegistryScanningConfigurationCommandInput, GetRegistryScanningConfigurationCommandOutput } from "../commands/GetRegistryScanningConfigurationCommand";
import { GetRepositoryPolicyCommandInput, GetRepositoryPolicyCommandOutput } from "../commands/GetRepositoryPolicyCommand";
import { InitiateLayerUploadCommandInput, InitiateLayerUploadCommandOutput } from "../commands/InitiateLayerUploadCommand";
import { ListImagesCommandInput, ListImagesCommandOutput } from "../commands/ListImagesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { PutAccountSettingCommandInput, PutAccountSettingCommandOutput } from "../commands/PutAccountSettingCommand";
import { PutImageCommandInput, PutImageCommandOutput } from "../commands/PutImageCommand";
import { PutImageScanningConfigurationCommandInput, PutImageScanningConfigurationCommandOutput } from "../commands/PutImageScanningConfigurationCommand";
import { PutImageTagMutabilityCommandInput, PutImageTagMutabilityCommandOutput } from "../commands/PutImageTagMutabilityCommand";
import { PutLifecyclePolicyCommandInput, PutLifecyclePolicyCommandOutput } from "../commands/PutLifecyclePolicyCommand";
import { PutRegistryPolicyCommandInput, PutRegistryPolicyCommandOutput } from "../commands/PutRegistryPolicyCommand";
import { PutRegistryScanningConfigurationCommandInput, PutRegistryScanningConfigurationCommandOutput } from "../commands/PutRegistryScanningConfigurationCommand";
import { PutReplicationConfigurationCommandInput, PutReplicationConfigurationCommandOutput } from "../commands/PutReplicationConfigurationCommand";
import { SetRepositoryPolicyCommandInput, SetRepositoryPolicyCommandOutput } from "../commands/SetRepositoryPolicyCommand";
import { StartImageScanCommandInput, StartImageScanCommandOutput } from "../commands/StartImageScanCommand";
import { StartLifecyclePolicyPreviewCommandInput, StartLifecyclePolicyPreviewCommandOutput } from "../commands/StartLifecyclePolicyPreviewCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdatePullThroughCacheRuleCommandInput, UpdatePullThroughCacheRuleCommandOutput } from "../commands/UpdatePullThroughCacheRuleCommand";
import { UpdateRepositoryCreationTemplateCommandInput, UpdateRepositoryCreationTemplateCommandOutput } from "../commands/UpdateRepositoryCreationTemplateCommand";
import { UploadLayerPartCommandInput, UploadLayerPartCommandOutput } from "../commands/UploadLayerPartCommand";
import { ValidatePullThroughCacheRuleCommandInput, ValidatePullThroughCacheRuleCommandOutput } from "../commands/ValidatePullThroughCacheRuleCommand";
/**
 * serializeAws_json1_1BatchCheckLayerAvailabilityCommand
 */
export declare const se_BatchCheckLayerAvailabilityCommand: (input: BatchCheckLayerAvailabilityCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchDeleteImageCommand
 */
export declare const se_BatchDeleteImageCommand: (input: BatchDeleteImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetImageCommand
 */
export declare const se_BatchGetImageCommand: (input: BatchGetImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetRepositoryScanningConfigurationCommand
 */
export declare const se_BatchGetRepositoryScanningConfigurationCommand: (input: BatchGetRepositoryScanningConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CompleteLayerUploadCommand
 */
export declare const se_CompleteLayerUploadCommand: (input: CompleteLayerUploadCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreatePullThroughCacheRuleCommand
 */
export declare const se_CreatePullThroughCacheRuleCommand: (input: CreatePullThroughCacheRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateRepositoryCommand
 */
export declare const se_CreateRepositoryCommand: (input: CreateRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateRepositoryCreationTemplateCommand
 */
export declare const se_CreateRepositoryCreationTemplateCommand: (input: CreateRepositoryCreationTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteLifecyclePolicyCommand
 */
export declare const se_DeleteLifecyclePolicyCommand: (input: DeleteLifecyclePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeletePullThroughCacheRuleCommand
 */
export declare const se_DeletePullThroughCacheRuleCommand: (input: DeletePullThroughCacheRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteRegistryPolicyCommand
 */
export declare const se_DeleteRegistryPolicyCommand: (input: DeleteRegistryPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteRepositoryCommand
 */
export declare const se_DeleteRepositoryCommand: (input: DeleteRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteRepositoryCreationTemplateCommand
 */
export declare const se_DeleteRepositoryCreationTemplateCommand: (input: DeleteRepositoryCreationTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteRepositoryPolicyCommand
 */
export declare const se_DeleteRepositoryPolicyCommand: (input: DeleteRepositoryPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeImageReplicationStatusCommand
 */
export declare const se_DescribeImageReplicationStatusCommand: (input: DescribeImageReplicationStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeImagesCommand
 */
export declare const se_DescribeImagesCommand: (input: DescribeImagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeImageScanFindingsCommand
 */
export declare const se_DescribeImageScanFindingsCommand: (input: DescribeImageScanFindingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribePullThroughCacheRulesCommand
 */
export declare const se_DescribePullThroughCacheRulesCommand: (input: DescribePullThroughCacheRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeRegistryCommand
 */
export declare const se_DescribeRegistryCommand: (input: DescribeRegistryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeRepositoriesCommand
 */
export declare const se_DescribeRepositoriesCommand: (input: DescribeRepositoriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeRepositoryCreationTemplatesCommand
 */
export declare const se_DescribeRepositoryCreationTemplatesCommand: (input: DescribeRepositoryCreationTemplatesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetAccountSettingCommand
 */
export declare const se_GetAccountSettingCommand: (input: GetAccountSettingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetAuthorizationTokenCommand
 */
export declare const se_GetAuthorizationTokenCommand: (input: GetAuthorizationTokenCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDownloadUrlForLayerCommand
 */
export declare const se_GetDownloadUrlForLayerCommand: (input: GetDownloadUrlForLayerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetLifecyclePolicyCommand
 */
export declare const se_GetLifecyclePolicyCommand: (input: GetLifecyclePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetLifecyclePolicyPreviewCommand
 */
export declare const se_GetLifecyclePolicyPreviewCommand: (input: GetLifecyclePolicyPreviewCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetRegistryPolicyCommand
 */
export declare const se_GetRegistryPolicyCommand: (input: GetRegistryPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetRegistryScanningConfigurationCommand
 */
export declare const se_GetRegistryScanningConfigurationCommand: (input: GetRegistryScanningConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetRepositoryPolicyCommand
 */
export declare const se_GetRepositoryPolicyCommand: (input: GetRepositoryPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1InitiateLayerUploadCommand
 */
export declare const se_InitiateLayerUploadCommand: (input: InitiateLayerUploadCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListImagesCommand
 */
export declare const se_ListImagesCommand: (input: ListImagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutAccountSettingCommand
 */
export declare const se_PutAccountSettingCommand: (input: PutAccountSettingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutImageCommand
 */
export declare const se_PutImageCommand: (input: PutImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutImageScanningConfigurationCommand
 */
export declare const se_PutImageScanningConfigurationCommand: (input: PutImageScanningConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutImageTagMutabilityCommand
 */
export declare const se_PutImageTagMutabilityCommand: (input: PutImageTagMutabilityCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutLifecyclePolicyCommand
 */
export declare const se_PutLifecyclePolicyCommand: (input: PutLifecyclePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutRegistryPolicyCommand
 */
export declare const se_PutRegistryPolicyCommand: (input: PutRegistryPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutRegistryScanningConfigurationCommand
 */
export declare const se_PutRegistryScanningConfigurationCommand: (input: PutRegistryScanningConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutReplicationConfigurationCommand
 */
export declare const se_PutReplicationConfigurationCommand: (input: PutReplicationConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SetRepositoryPolicyCommand
 */
export declare const se_SetRepositoryPolicyCommand: (input: SetRepositoryPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartImageScanCommand
 */
export declare const se_StartImageScanCommand: (input: StartImageScanCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartLifecyclePolicyPreviewCommand
 */
export declare const se_StartLifecyclePolicyPreviewCommand: (input: StartLifecyclePolicyPreviewCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePullThroughCacheRuleCommand
 */
export declare const se_UpdatePullThroughCacheRuleCommand: (input: UpdatePullThroughCacheRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateRepositoryCreationTemplateCommand
 */
export declare const se_UpdateRepositoryCreationTemplateCommand: (input: UpdateRepositoryCreationTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UploadLayerPartCommand
 */
export declare const se_UploadLayerPartCommand: (input: UploadLayerPartCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ValidatePullThroughCacheRuleCommand
 */
export declare const se_ValidatePullThroughCacheRuleCommand: (input: ValidatePullThroughCacheRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1BatchCheckLayerAvailabilityCommand
 */
export declare const de_BatchCheckLayerAvailabilityCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchCheckLayerAvailabilityCommandOutput>;
/**
 * deserializeAws_json1_1BatchDeleteImageCommand
 */
export declare const de_BatchDeleteImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchDeleteImageCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetImageCommand
 */
export declare const de_BatchGetImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetImageCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetRepositoryScanningConfigurationCommand
 */
export declare const de_BatchGetRepositoryScanningConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetRepositoryScanningConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1CompleteLayerUploadCommand
 */
export declare const de_CompleteLayerUploadCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CompleteLayerUploadCommandOutput>;
/**
 * deserializeAws_json1_1CreatePullThroughCacheRuleCommand
 */
export declare const de_CreatePullThroughCacheRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePullThroughCacheRuleCommandOutput>;
/**
 * deserializeAws_json1_1CreateRepositoryCommand
 */
export declare const de_CreateRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1CreateRepositoryCreationTemplateCommand
 */
export declare const de_CreateRepositoryCreationTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRepositoryCreationTemplateCommandOutput>;
/**
 * deserializeAws_json1_1DeleteLifecyclePolicyCommand
 */
export declare const de_DeleteLifecyclePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLifecyclePolicyCommandOutput>;
/**
 * deserializeAws_json1_1DeletePullThroughCacheRuleCommand
 */
export declare const de_DeletePullThroughCacheRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePullThroughCacheRuleCommandOutput>;
/**
 * deserializeAws_json1_1DeleteRegistryPolicyCommand
 */
export declare const de_DeleteRegistryPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRegistryPolicyCommandOutput>;
/**
 * deserializeAws_json1_1DeleteRepositoryCommand
 */
export declare const de_DeleteRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRepositoryCommandOutput>;
/**
 * deserializeAws_json1_1DeleteRepositoryCreationTemplateCommand
 */
export declare const de_DeleteRepositoryCreationTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRepositoryCreationTemplateCommandOutput>;
/**
 * deserializeAws_json1_1DeleteRepositoryPolicyCommand
 */
export declare const de_DeleteRepositoryPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRepositoryPolicyCommandOutput>;
/**
 * deserializeAws_json1_1DescribeImageReplicationStatusCommand
 */
export declare const de_DescribeImageReplicationStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImageReplicationStatusCommandOutput>;
/**
 * deserializeAws_json1_1DescribeImagesCommand
 */
export declare const de_DescribeImagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImagesCommandOutput>;
/**
 * deserializeAws_json1_1DescribeImageScanFindingsCommand
 */
export declare const de_DescribeImageScanFindingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImageScanFindingsCommandOutput>;
/**
 * deserializeAws_json1_1DescribePullThroughCacheRulesCommand
 */
export declare const de_DescribePullThroughCacheRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePullThroughCacheRulesCommandOutput>;
/**
 * deserializeAws_json1_1DescribeRegistryCommand
 */
export declare const de_DescribeRegistryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRegistryCommandOutput>;
/**
 * deserializeAws_json1_1DescribeRepositoriesCommand
 */
export declare const de_DescribeRepositoriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRepositoriesCommandOutput>;
/**
 * deserializeAws_json1_1DescribeRepositoryCreationTemplatesCommand
 */
export declare const de_DescribeRepositoryCreationTemplatesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRepositoryCreationTemplatesCommandOutput>;
/**
 * deserializeAws_json1_1GetAccountSettingCommand
 */
export declare const de_GetAccountSettingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAccountSettingCommandOutput>;
/**
 * deserializeAws_json1_1GetAuthorizationTokenCommand
 */
export declare const de_GetAuthorizationTokenCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAuthorizationTokenCommandOutput>;
/**
 * deserializeAws_json1_1GetDownloadUrlForLayerCommand
 */
export declare const de_GetDownloadUrlForLayerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDownloadUrlForLayerCommandOutput>;
/**
 * deserializeAws_json1_1GetLifecyclePolicyCommand
 */
export declare const de_GetLifecyclePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetLifecyclePolicyCommandOutput>;
/**
 * deserializeAws_json1_1GetLifecyclePolicyPreviewCommand
 */
export declare const de_GetLifecyclePolicyPreviewCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetLifecyclePolicyPreviewCommandOutput>;
/**
 * deserializeAws_json1_1GetRegistryPolicyCommand
 */
export declare const de_GetRegistryPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRegistryPolicyCommandOutput>;
/**
 * deserializeAws_json1_1GetRegistryScanningConfigurationCommand
 */
export declare const de_GetRegistryScanningConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRegistryScanningConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1GetRepositoryPolicyCommand
 */
export declare const de_GetRepositoryPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRepositoryPolicyCommandOutput>;
/**
 * deserializeAws_json1_1InitiateLayerUploadCommand
 */
export declare const de_InitiateLayerUploadCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<InitiateLayerUploadCommandOutput>;
/**
 * deserializeAws_json1_1ListImagesCommand
 */
export declare const de_ListImagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListImagesCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1PutAccountSettingCommand
 */
export declare const de_PutAccountSettingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutAccountSettingCommandOutput>;
/**
 * deserializeAws_json1_1PutImageCommand
 */
export declare const de_PutImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutImageCommandOutput>;
/**
 * deserializeAws_json1_1PutImageScanningConfigurationCommand
 */
export declare const de_PutImageScanningConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutImageScanningConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1PutImageTagMutabilityCommand
 */
export declare const de_PutImageTagMutabilityCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutImageTagMutabilityCommandOutput>;
/**
 * deserializeAws_json1_1PutLifecyclePolicyCommand
 */
export declare const de_PutLifecyclePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutLifecyclePolicyCommandOutput>;
/**
 * deserializeAws_json1_1PutRegistryPolicyCommand
 */
export declare const de_PutRegistryPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRegistryPolicyCommandOutput>;
/**
 * deserializeAws_json1_1PutRegistryScanningConfigurationCommand
 */
export declare const de_PutRegistryScanningConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRegistryScanningConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1PutReplicationConfigurationCommand
 */
export declare const de_PutReplicationConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutReplicationConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1SetRepositoryPolicyCommand
 */
export declare const de_SetRepositoryPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SetRepositoryPolicyCommandOutput>;
/**
 * deserializeAws_json1_1StartImageScanCommand
 */
export declare const de_StartImageScanCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartImageScanCommandOutput>;
/**
 * deserializeAws_json1_1StartLifecyclePolicyPreviewCommand
 */
export declare const de_StartLifecyclePolicyPreviewCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartLifecyclePolicyPreviewCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePullThroughCacheRuleCommand
 */
export declare const de_UpdatePullThroughCacheRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePullThroughCacheRuleCommandOutput>;
/**
 * deserializeAws_json1_1UpdateRepositoryCreationTemplateCommand
 */
export declare const de_UpdateRepositoryCreationTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRepositoryCreationTemplateCommandOutput>;
/**
 * deserializeAws_json1_1UploadLayerPartCommand
 */
export declare const de_UploadLayerPartCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UploadLayerPartCommandOutput>;
/**
 * deserializeAws_json1_1ValidatePullThroughCacheRuleCommand
 */
export declare const de_ValidatePullThroughCacheRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ValidatePullThroughCacheRuleCommandOutput>;
