export type SegmentElement = string | number;
export declare class Version {
    static ANCHORED_VERSION_PATTERN: RegExp;
    private readonly _version;
    version(): string;
    toString(): string;
    static isCorrect(version: unknown): boolean;
    static create(input: unknown): Version | null;
    constructor(version: unknown);
    bump(): Version;
    strictEql(other: Version): boolean;
    isPrerelease(): boolean;
    release(): Version;
    approximateRecommendation(): string;
    compare(other: Version | null): number;
    canonicalSegments(): SegmentElement[];
    getSegments(): SegmentElement[];
    splitSegments(): [number[], SegmentElement[]];
}
export declare const create: (val: unknown) => Version;
