export declare enum LogLevel {
    FINE = 0,
    DEBUG = 1,
    INFO = 2,
    WARN = 3,
    SEVERE = 4,
    NONE = 5
}
export declare type LogLevelName = "FINE" | "DEBUG" | "INFO" | "WARN" | "SEVERE" | "NONE";
export interface ILogger {
    /**
     * This logger's configured minimum log level
     */
    level: LogLevel;
    fine(...args: any[]): void;
    debug(...args: any[]): void;
    info(...args: any[]): void;
    warn(...args: any[]): void;
    severe(...args: any[]): void;
}
//# sourceMappingURL=logger.d.ts.map