import type { IRandom } from "../api";
/**
 * HOF. Returns zero-arg function, yielding values in geometric distribution,
 * aka the number of independent trials required for the first occurrence of
 * success, and each trial using the given success probability `p`.
 *
 * @remarks
 * Returns 0 for p <= 0 and 1 for p >= 1.
 *
 * Reference: https://en.wikipedia.org/wiki/Geometric_distribution
 *
 * @param rnd
 * @param p - probability (0,1]
 */
export declare const geometric: (rnd?: IRandom, p?: number) => () => number;
//# sourceMappingURL=geometric.d.ts.map