# Emojibase

[![Build Status](https://github.com/milesj/emojibase/workflows/Build/badge.svg)](https://github.com/milesj/emojibase/actions?query=branch%3Amaster)
[![npm version](https://badge.fury.io/js/emojibase.svg)](https://www.npmjs.com/package/emojibase)
[![npm deps](https://david-dm.org/milesj/emojibase.svg?path=packages/core)](https://www.npmjs.com/package/emojibase)
[![jsDelivr Hits](https://data.jsdelivr.com/v1/package/npm/emojibase-data/badge?style=rounded)](https://www.jsdelivr.com/package/npm/emojibase-data)

> Emojibase, the ultimate emoji database.

A collection of lightweight, up-to-date, pre-generated, specification compliant, localized emoji
JSON datasets, regex patterns, and more.

#### Features

- Supports the latest [Emoji 15.1](https://emojipedia.org/emoji-15.1/),
  [Unicode 15.1](http://unicode.org/versions/Unicode15.1.0/), and
  [CLDR 45](http://cldr.unicode.org/index/downloads/cldr-45) release versions
- Built directly from the [emoji data source files](http://unicode.org/Public/emoji/)
- Based on the official [Unicode Technical Standard #51](http://unicode.org/reports/tr51/)
- With localization provided by
  [Unicode Technical Standard #35](http://unicode.org/reports/tr35/tr35-general.html#Annotations)

## Documentation

[https://emojibase.dev](https://emojibase.dev)
